/* $Id: FreeTDS.h,v 1.3 2003/10/14 23:58:47 mpeppler Exp $

   Copyright (c) 1997-2003 Michael Peppler

   You may distribute under the terms of either the GNU General Public
   License or the Artistic License, as specified in the Perl README file.

*/



#define NEED_DBIXS_VERSION 8

#include <DBIXS.h>		/* installed by the DBI module	*/

#include <ctpublic.h>

/* These defines avoid name clashes for multiple statically linked DBD's    */
 
#define dbd_init        ftds_init
#define dbd_db_login6       ftds_db_login
#define dbd_db_do       ftds_db_do
#define dbd_db_commit       ftds_db_commit
#define dbd_db_rollback     ftds_db_rollback
#define dbd_db_disconnect   ftds_db_disconnect
#define dbd_discon_all   ftds_discon_all
#define dbd_db_destroy      ftds_db_destroy
#define dbd_db_STORE_attrib ftds_db_STORE_attrib
#define dbd_db_FETCH_attrib ftds_db_FETCH_attrib
#define dbd_st_prepare      ftds_st_prepare
#define dbd_st_rows     ftds_st_rows
#define dbd_st_execute      ftds_st_execute
#define dbd_st_fetch        ftds_st_fetch
#define dbd_st_finish       ftds_st_finish
#define dbd_st_destroy      ftds_st_destroy
#define dbd_st_blob_read    ftds_st_blob_read
#define dbd_st_STORE_attrib ftds_st_STORE_attrib
#define dbd_st_FETCH_attrib ftds_st_FETCH_attrib
#define dbd_describe        ftds_describe
#define dbd_bind_ph     ftds_bind_ph



/* read in our implementation details */

#include "dbdimp.h"

#if defined(CS_VERSION_125)
#define CTLIB_VERSION   CS_VERSION_125
#else 
#if defined(CS_VERSION_120)
#define CTLIB_VERSION   CS_VERSION_120
#else 
#if defined(CS_VERSION_110)
#define CTLIB_VERSION   CS_VERSION_110
#else
#define CTLIB_VERSION	CS_VERSION_100
#endif
#endif
#endif

/*#define CTLIB_VERSION	CS_VERSION_100 */

#ifndef MAX
#define MAX(X,Y)	(((X) > (Y)) ? (X) : (Y))
#endif

#ifndef MIN
#define MIN(X,Y)	(((X) < (Y)) ? (X) : (Y))
#endif


#if !defined(FreeTDS_h)
#define FreeTDS_h 1

void     ftds_init _((dbistate_t *dbistate));

int      ftds_discon_all _((SV *drh, imp_drh_t *imp_drh));

int      ftds_db_login _((SV *dbh, imp_dbh_t *imp_dbh, char *dbname, char *uid, char *pwd, SV *attribs));
int      ftds_db_do _((SV *sv, char *statement));
int      ftds_db_commit     _((SV *dbh, imp_dbh_t *imp_dbh));
int      ftds_db_rollback   _((SV *dbh, imp_dbh_t *imp_dbh));
int      ftds_db_disconnect _((SV *dbh, imp_dbh_t *imp_dbh));
void     ftds_db_destroy    _((SV *dbh, imp_dbh_t *imp_dbh));
int      ftds_db_STORE_attrib _((SV *dbh, imp_dbh_t *imp_dbh, SV *keysv, SV *valuesv));
SV      *ftds_db_FETCH_attrib _((SV *dbh, imp_dbh_t *imp_dbh, SV *keysv));

int      ftds_st_prepare _((SV *sth, imp_sth_t *imp_sth,
                char *statement, SV *attribs));
int      ftds_st_rows    _((SV *sth, imp_sth_t *imp_sth));
int      ftds_st_execute _((SV *sth, imp_sth_t *imp_sth));
AV      *ftds_st_fetch   _((SV *sth, imp_sth_t *imp_sth));
int      ftds_st_finish  _((SV *sth, imp_sth_t *imp_sth));
void     ftds_st_destroy _((SV *sth, imp_sth_t *imp_sth));
int      ftds_st_blob_read _((SV *sth, imp_sth_t *imp_sth,
                int field, long offset, long len, SV *destrv, long destoffset));
int      ftds_ct_get_data _((SV *sth, imp_sth_t *imp_sth, 
			    int column, SV *bufrv, int buflen));
int      ftds_ct_data_info _((SV *sth, imp_sth_t *imp_sth, int action, 
			     int column, SV *attr));
int      ftds_ct_send_data _((SV *sth, imp_sth_t *imp_sth, char *buffer, 
			     int size));
int      ftds_ct_prepare_send _((SV *sth, imp_sth_t *));
int      ftds_ct_finish_send _((SV *sth, imp_sth_t *));
int      ftds_st_STORE_attrib _((SV *sth, imp_sth_t *imp_sth, SV *keysv, SV *valuesv));
SV      *ftds_st_FETCH_attrib _((SV *sth, imp_sth_t *imp_sth, SV *keysv));
 
int      ftds_describe _((SV *sth, imp_sth_t *imp_sth));
int      ftds_bind_ph  _((SV *sth, imp_sth_t *imp_sth,
                SV *param, SV *value, IV sql_type, SV *attribs,
				int is_inout, IV maxlen));

int      ftds_set_timeout _((int timeout));
int      ftds_st_cancel _((SV *sth, imp_sth_t *imp_sth));

#endif /* defined FreeTDS_h */

/* end of FreeTDS.h */
