#!/usr/local/bin/perl
#
# $Id: autocommit.t,v 1.4 2003/10/21 21:38:11 mpeppler Exp $

use lib 'blib/lib';
use lib 'blib/arch';

use lib 't';

use _test;

use Test::More;

use strict;

BEGIN { plan tests => 6; }

use_ok('DBI');

#DBI->trace(3);

my ($Uid, $Pwd, $Srv, $Db) = _test::get_info();

my $dbh = DBI->connect("dbi:FreeTDS:server=$Srv;database=$Db", $Uid, $Pwd, {PrintError => 0});

ok(defined($dbh), 'Connected');

$dbh->do("create table #ttt (foo varchar(20), bar int)");
$dbh->{AutoCommit} = 0;

#DBI->trace(3);
my $rows = 0;
my $rc;
$rc = $dbh->do("insert #ttt values('a string', 1)");
$rows += $rc;
$rc = $dbh->do("insert #ttt values('another string', 2)");
$rows += $rc;
$rc = $dbh->do("insert #ttt values('foodiboo', 3)");
$rows += $rc;
$rc = $dbh->do("insert #ttt values('a string', 4)");
$rows += $rc;
is($rows, 4, 'Rollback [insert]');
$dbh->rollback;
my $sth = $dbh->prepare("select * from #ttt");
$sth->execute;
my $found = 0;
while(my $d = $sth->fetch) {
    print "@$d\n";
    ++$found;
}
is($found, 0, 'Rollback');

$rows = 0;
$rc = $dbh->do("insert #ttt values('a string', 1)");
$rows += $rc;
$rc = $dbh->do("insert #ttt values('another string', 2)");
$rows += $rc;
$rc = $dbh->do("insert #ttt values('foodiboo', 3)");
$rows += $rc;
$rc = $dbh->do("insert #ttt values('a string', 4)");
$rows += $rc;
print "got $rows\n";
is($rows, 4, 'Commit [insert]');
$dbh->commit;

$sth = $dbh->prepare("select * from #ttt");
$sth->execute;
$found = 0;
while(my $d = $sth->fetch) {
    print "@$d\n";
    ++$found;
}
is($found, 4, 'Commit');

$dbh->disconnect;


