#!/usr/local/bin/perl
#
# $Id: nsql.t,v 1.3 2003/10/14 23:58:47 mpeppler Exp $

use lib 'blib/lib';
use lib 'blib/arch';

use lib 't';

use _test;
use strict;
use Test::More;

BEGIN { plan tests => 5;}

use_ok('DBI');

my ($Uid, $Pwd, $Srv, $Db) = _test::get_info();

my $dbh = DBI->connect("dbi:FreeTDS:server=$Srv;database=$Db", $Uid, $Pwd, {syb_deadlock_retry=>10, syb_deadlock_verbose=>1});

ok(defined($dbh), 'Connect');

my @d = $dbh->func("select * from sysusers", 'ARRAY', 'nsql');
ok(@d && scalar(@d) > 0, 'nsql');
foreach (@d) {
    local $^W = 0;
    print "@$_\n";
}
#ok(print "ok 3\n";


my @tmp;
sub cb {
    my @data = @_;
    local $^W = 0;
    print "@data\n";
    push(@tmp, join(' ', @data));

    1;
}
@d = $dbh->func("select * from sysusers", 'ARRAY', \&cb, 'nsql');
ok(scalar(@tmp) > 0, 'nsql callback');
ok($d[0] == 1, 'nsql return value');
#print "ok 4\n";
