#!/usr/local/bin/perl
#
# $Id: transact.t,v 1.3 2003/10/14 23:58:47 mpeppler Exp $

use lib 'blib/lib';
use lib 'blib/arch';

use lib 't';

use _test;

use strict;
use Test::More;

BEGIN { plan tests => 3;}
use_ok('DBI');

my ($Uid, $Pwd, $Srv, $Db) = _test::get_info();

#DBI->trace(3);
my $dbh = DBI->connect("dbi:FreeTDS:server=$Srv;database=$Db", $Uid, $Pwd, {syb_chained_txn=>1,AutoCommit=>0, PrintError => 1});
#exit;
ok(defined($dbh), 'Connect');

$dbh->do("create table #ttt (foo varchar(20), bar int)");

$dbh->do("begin tran foo");
$dbh->do("insert #ttt values('a string', 1)");
$dbh->do("insert #ttt values('another string', 2)");
$dbh->do("insert #ttt values('foodiboo', 3)");
$dbh->do("insert #ttt values('a string', 4)");
$dbh->do("commit tran foo");
my $sth = $dbh->prepare("select * from #ttt");
$sth->execute;
my $found = 0;
while(my $d = $sth->fetch) {
    print "@$d\n";
    ++$found;
}
ok($found > 0, 'Rows fetched');

#$dbh->{AutoCommit} = 0;
#DBI->trace(3);
#$sth = $dbh->prepare("select * from #ttt");
#$dbh->{AutoCommit} = 0;
#$sth->execute;
#$sth->fetch;
#$sth->finish;
#$sth->execute;
#while(my $d = $sth->fetch) {
#    print "@$d\n";
#    ++$found;
#}
#$sth->finish;

#$dbh->commit;



$dbh->disconnect;


