#!/usr/local/bin/perl
#
# $Id: xblob.t,v 1.5 2003/10/14 23:58:47 mpeppler Exp $

use lib 'blib/lib';
use lib 'blib/arch';

use lib 't';

use _test;

use strict;
use Test::More;


BEGIN { plan tests => 6;}
BEGIN { use_ok('DBI', qw(:sql_types)); }

my ($Uid, $Pwd, $Srv, $Db) = _test::get_info();
#DBI->trace(3);
my $dbh = DBI->connect("dbi:FreeTDS:server=$Srv;database=$Db", $Uid, $Pwd, {PrintError=>1});
#exit;
ok(defined($dbh), 'Connect');

SKIP: {
    skip "ct_get/send_data() not supported by this version of FreeTDS", 4 unless $dbh->{syb_ct_data_supported};

    my $rc = $dbh->do("create table blob_test(id int, data image null, foo varchar(30))");
    ok(defined($rc), 'Create table');

    open(IN, "t/screen.jpg") || die "Can't open t/screen.jpg: $!";
    my $image = join('', <IN>);
    close(IN);
    my $heximg = unpack('H*', $image);
    $rc = $dbh->do("insert blob_test(id, data, foo) values(1, '', 'screen.jpg')");
    ok(defined($rc), 'Insert');
    
    my $sth = $dbh->prepare("select id, data from blob_test");
    #$sth->{syb_no_bind_blob} = 1;
    $sth->execute;
    while($sth->fetch) {
	#    my $d;
	#    $sth->func(2, \$d, 0, 'ct_get_data');
	
	$sth->func('CS_GET', 2, 'ct_data_info') || print $sth->errstr, "\n";
    }
    $sth->func('ct_prepare_send') || print $sth->errstr, "\n";
    $sth->func('CS_SET', 2, {total_txtlen => length($image)}, 'ct_data_info') || print $sth->errstr, "\n";
    $sth->func($image, length($image), 'ct_send_data') || print $sth->errstr, "\n";
    $sth->func('ct_finish_send') || print $sth->errstr, "\n";
    
    #$dbh->{LongReadLen} = 100000;
    $sth = $dbh->prepare("select id, data from blob_test");
    $dbh->{LongReadLen} = 100000;
    #DBI->trace(3);
    $sth->{syb_no_bind_blob} = 1;
    $sth->execute;
    my $heximg2 = '';
    my $size = 0;
    while(my $d = $sth->fetch) {
	my $data;
	open(OUT, ">/tmp/mp_conf.jpg") || die "Can't open /tmp/mp_conf.jpg: $!";
	while(1) {
	    my $read = $sth->func(2, \$data, 1024, 'ct_get_data');
	    $heximg2 .= unpack('H*', $data);
	    $size += $read;
	    last unless $read == 1024;
	    print OUT $data;
	}
	close(OUT);
    }
    
    warn "Got $size bytes\n";
    
    ok($heximg eq $heximg2, 'Data matches');
    
    $rc = $dbh->do("drop table blob_test");
    
    ok(defined($rc), 'Drop table');
}

$dbh->disconnect;
